Attribute VB_Name = "AdaptEphemerisToWorkbook"
' Functions for adapting the ephemeris functions to the worksheets

Public Function planet_lon_proj(ipl As Long, jd_ut As Double, lon As Double, lat As Double, alt As Double) As Double
   planet_lon_proj = getLonProj(ipl, jd_ut, lon, lat, alt)
End Function

Public Function planet_lon(ipl As Long, jd_ut As Double, lon As Double, lat As Double, alt As Double) As Double
   planet_lon = getLon(ipl, jd_ut, lon, lat, alt)
End Function

Public Function munpos(ipl As Long, jd_ut As Double, lon As Double, lat As Double, alt As Double) As Double
   munpos = getMP(ipl, jd_ut, lon, lat, alt)
End Function

Public Function ra(ipl As Long, jd_ut As Double, lon As Double, lat As Double, alt As Double) As Double
   ra = getRA(ipl, jd_ut, lon, lat, alt)
End Function

Public Function decl(ipl As Long, jd_ut As Double, lon As Double, lat As Double, alt As Double) As Double
   decl = getDecl(ipl, jd_ut, lon, lat, alt)
End Function

Public Function cusp(i As Long, jd_ut As Double, lon As Double, lat As Double) As Double
  cusp = getHouse(i, jd_ut, lon, lat)
End Function

Public Function check_ephe_path(ephe_path As String) As String

  Dim fso As Object
  Set fso = CreateObject("Scripting.FileSystemObject")

  
  If fso.FolderExists(ephe_path) Then
    swe_set_ephe_path (ephe_path)
    check_ephe_path = "OK"
  Else
    check_ephe_path = "NOT OK"
  End If


End Function

Public Function set_ephe_path(Optional ephe_path As String = "")

  If ephe_path = "" Then ephe_path = Cells(1, 5).Value

  swe_set_ephe_path (ephe_path)
  ephe_path_set = True

End Function

Public Function set_message(day As Long, month As Long, year As Long, time As String, gregflag As Long, lon As Double, lat As Double, alt As Double)

  set_message = getError()

End Function



